<?php
/************************************************************************
db_cart Class ver 1.11 -
This universal shopping cart script is powered by MySQL and works with external customer and product related tables.

Copyright (c) 2005, Olaf Lederer
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the finalwebsites.com nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

_________________________________________________________________________
available at http://www.finalwebsites.com 
Comments & suggestions: http://www.finalwebsites.com/contact.php

*************************************************************************/
require("db_config.php");
if (!session_id()) session_start();
error_reporting(E_ALL);
class db_cart {
	
	var $error;
	var $customer;
	var $curr_product;
	
	var $ship_id;
	var $ship_name;
	var $ship_fname;
	var $ship_address;
	var $ship_pc;
	var $ship_city;
	var $ship_country; 
	var $ship_msg;
	var $ship_email;
	var $ship_payment;
	var $ship_payment_label;
	var $ship_costs ;
//	var $pay_costs = 0 ;
	var $order_array = array();
	
	
	// constructor ...
	function db_cart($customer_no = 0) {
		$conn = mysql_connect(DB_SERVER, DB_USER, DB_PASSWORD);
		mysql_select_db(DB_NAME, $conn);
		$this->error = "&nbsp;";
		if (!isset($_SESSION['order_id'])) {
			$this->get_order($customer_no);
			//$this->remove_old_orders(false); // use false if everyting older 1 day should be removed
		}
	}
	// get all messages from here (add your own language here)
	function messages($number) {
		$msg = array();
		// general error messages
		$msg[1] = "Unknown database error, please try it again.";
		$msg[2] = "Unknown application error, please contact the system administrator.";
		$msg[3] = "Unknown database error, but the order is send by e-mail.";
		// messages related to cart activity
		$msg[11] = "Added the product to your cart.";
		$msg[12] = "Updated the order row in your cart.";
		$msg[13] = "Can't add/update the product, please try it again.";
		$msg[14] = "Votre panier est vide.";
		$msg[15] = "Removed the order row from your cart.";
		// checkout related messages
		$msg[21] = "Shipment address is successfully modified.";
		$msg[22] = "Your order is processed and a copy is send to you by e-mail.";		
		$msg[23] = "Veuillez compl&eacute;ter tous les champs obligatoires !";		
		// messages used inside the mail
		$msg[51] = "Commande sur ".$_SERVER['HTTP_HOST']." le ".date(DATE_FORMAT);
		$msg[52] = "Bonjour,\r\n\r\nrecevez ce courriel suite &agrave; votre commande on-line.\r\n\r\n";
		$msg[53] = "\r\nLe total de votre commande est : ".$this->format_value($this->show_total_value(), false);
		$msg[53] .= (INCL_VAT) ? " (incl. VAT)" : "";
		$msg[54] = "\r\nTVA incluse : ".$this->format_value($this->create_total_VAT(), false)."\r\n\r\n";
		$msg[55] = "\r\n\r\n_______________________________________\r\nMeilleures salutations\r\n".SITE_MASTER."\r\n\r\n";
		// if you change the format next then change the values in the mail method, too.
		$msg[56] = sprintf("\t%-10s  %-30s  %-20s  %-12s\r\n", "Quantit&eacute;", "Description", "N&deg; art.", "Prix"); 
		$msg[57] = "Livraison &agrave; / command&eacute; par :\r\n";
		$msg[57] .= $this->ship_name."\r\n".$this->ship_address."\r\n".$this->ship_pc." ".$this->ship_city."\r\n".$this->ship_country;
		$msg[58] = ($this->ship_msg != "") ? "\r\n\r\nMessage :\r\n".$this->ship_msg."\r\n" : ""; 
		$msg[59] = ($this->ship_payment != "") ? "\r\n\r\nPayement :\r\n".$this->ship_payment_label."\r\n" : ""; 
		return $msg[$number];
	}
	// mail message to send critical error's to the admin
	function send_admin_mail() {
	    // mail to admin (comes with the next version)
	}
	// function to handle old orders
	// a method to clean up old orders, $remove_only_zeros is an option to handle records for records with a customer number
	function remove_old_orders($remove_only_zeros = true) {
		if (RECOVER_ORDER) {
			$sql = sprintf("DELETE FROM %s WHERE open = 'y' AND  order_date < (NOW() - %d)", ORDERS, VALID_UNTIL * 86400);
		} else {
//			$sql = sprintf("DELETE FROM %s WHERE open = 'y' AND customer = %d AND order_date < (NOW() - %d)", ORDERS, VALID_UNTIL * 86400);
			$sql = sprintf("DELETE FROM %s WHERE open = 'y' AND order_date < (NOW() - %d)", ORDERS, VALID_UNTIL * 86400);
		}
		$sql .= ($remove_only_zeros) ? " AND customer = 0" : "";
		mysql_query($sql);
	}
	// get an existing order for a customer, or insert a new one id none exist
	function get_order($customer) {
		$sql_check = sprintf("SELECT id FROM %s WHERE customer = %d AND open = 'y'", ORDERS, $customer);
		if ($res_check = mysql_query($sql_check)) {
			if (mysql_num_rows($res_check) > 0 && $customer != 0) {
				$_SESSION['order_id'] = mysql_result($res_check, 0, "id");
			} else {
				$sql_new = sprintf("INSERT INTO %s (customer, order_date) VALUES (%d, NOW())", ORDERS, $customer);
				if (mysql_query($sql_new)) {
					$_SESSION['order_id'] = mysql_insert_id();
				} else {
					$this->error = $this->messages(1);
				}
			}
		} else {
			$this->error = $this->messages(1);
		}
	}
	// this method will chek if a order row for this product already exist
	function check_existing_row($product) {
		$sql = sprintf("SELECT id FROM %s WHERE order_id = %d AND product_id = '%s'", ORDER_ROWS, $_SESSION['order_id'], $product);
		if ($result = mysql_query($sql)) {
			if (mysql_num_rows($result) == 1) {
				$this->curr_product = mysql_result($result, 0, "id");
				return "old";
			} else {
				return "new";
			}
		} else {
			return "error";
		}	
	}
	// insert a not existing row to the current order
	function insert_row($prod_id, $prod_name, $quantity, $price, $vat_amount = VAT_VALUE) {
		$sql = sprintf("INSERT INTO %s (order_id, product_id, product_name, price, vat_perc, quantity) VALUES (%d, '%s', '%s', %f, %f, %d)", ORDER_ROWS, $_SESSION['order_id'], $prod_id, $prod_name, $price, $vat_amount, $quantity);
		// if (mysql_query($sql)) {
			// $this->error = $this->messages(11);
		// } else {
			// $this->error = $this->messages(1);
		// }	
		if (!mysql_query($sql)) {
			$this->error = $this->messages(1);
		}	
	}
	// update/replace a single order row with the new quantity
	function update_row($row_id, $quantity, $replace = "yes") {
		if ($quantity == 0) {
			$this->delete_row($row_id);
		} else {
			$new_quant = ($replace == "no") ? "quantity + ".$quantity : $quantity;
			$sql = sprintf("UPDATE %s SET quantity = %s WHERE id = %d AND order_id = %d", ORDER_ROWS, $new_quant, $row_id, $_SESSION['order_id']);
			// if (mysql_query($sql)) {
				// $this->error = $this->messages(12);
			// } else {
				// $this->error = $this->messages(1);
			// }
			if (!mysql_query($sql)) {
				$this->error = $this->messages(1);
			}
		}
	}
	// function to delete a single row
	function delete_row($row_id) {
		$sql = sprintf("DELETE FROM %s WHERE id = %d AND order_id = %d", ORDER_ROWS, $row_id, $_SESSION['order_id']);
		// if (mysql_query($sql)) {
			// $this->error = $this->messages(15);
		// } else {
			// $this->error = $this->messages(1);
		// }	
		if (!mysql_query($sql)) {
			$this->error = $this->messages(1);
		}	
	}
	// handle a order row while using the methodes above
	function handle_cart_row($prod_id, $prod_name, $quantity, $price, $replace = "no", $vat_amount = VAT_VALUE) {
		$check_row = $this->check_existing_row($prod_id);
		if ($check_row == "old") {
			$this->update_row($this->curr_product, $quantity, $replace);
		} elseif ($check_row == "new") {
			$this->insert_row($prod_id, $prod_name, $quantity, $price, $vat_amount);
		} else {
			$this->error = $this->messages(13);
		}
	}
	// get the number of ordered rows which belong to this customer
	function get_number_of_records() {
		$sql = sprintf("SELECT COUNT(*) AS num FROM %s AS r, %s AS ord WHERE ord.id = r.order_id AND ord.id = %d AND ord.open = 'y'", ORDER_ROWS, ORDERS, $_SESSION['order_id']);
		if ($result = mysql_query($sql)) {
			return mysql_result($result, 0, "num");
		} else {
			$this->error = $this->messages(1);
			return;
		}
	}
	// get all order rows from the DB and store them in to an array
	function show_ordered_rows() {
		$sql = sprintf("SELECT r.id, r.product_id, r.product_name, r.price, r.vat_perc, r.quantity FROM %s AS r, %s AS ord WHERE ord.id = r.order_id AND ord.id = %d AND ord.open = 'y'", ORDER_ROWS, ORDERS, $_SESSION['order_id']);
		if ($result = mysql_query($sql)) {
			if (mysql_num_rows($result) > 0) {
				$counter = 0;
				while ($row = mysql_fetch_assoc($result)) {
					foreach($row as $key => $val) {
						$this->order_array[$counter][$key] = $val;
					}
					$counter++;
				}
			} else {
				$this->error = $this->messages(14);
			}
		} else {
			$this->error = $this->messages(1);
		}
	}
	// show total value of the current cart
	function show_total_value() {
		$sql = sprintf("SELECT SUM(quantity * price) AS total FROM %s WHERE order_id = %d", ORDER_ROWS, $_SESSION['order_id']);
		if (!$result = mysql_query($sql)) {
			$this->error = $this->messages(1);
			return;
		} else {
			$total_amount = mysql_result($result, 0, "total");
			mysql_free_result($result);
			return $total_amount;
		}
	}
	// calculate VAT, switch between true and false to handle netto or brutto prices
	function create_total_VAT() {
		$sql = sprintf("SELECT price, vat_perc, quantity FROM %s WHERE order_id = %d", ORDER_ROWS, $_SESSION['order_id']);
		if (!$result = mysql_query($sql)) {
			$this->error = $this->messages(1);
		} else {
			$vat = 0;
			if (mysql_num_rows($result) > 0) {
				while ($obj = mysql_fetch_object($result)) {
					$vat_dec = $obj->vat_perc / 100;
					if (INCL_VAT) {
						$vat = $vat + ($obj->price * $obj->quantity) / (1 + $vat_dec) * $vat_dec;
					} else {
						$vat = $vat + ($obj->price * $obj->quantity) * $vat_dec;
					}
				}
			}
		}
		mysql_free_result($result);
		return $vat;
	}
	// check if already an shipment record exist, if yes return the data
	function check_return_shipment() {
		$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE order_id = %d", SHIP_ADDRESS, $_SESSION['order_id']);
		if ($result = mysql_query($sql)) {
			if (mysql_result($result, 0, "test") == 1) {
				return true;
			} else {
				return false;
			}
		} else {
			$this->error = $this->messages(1);
			return false; 
		}
	}
	// read the current shipment data and set the variabels
	function set_shipment_data() {
		if (!$this->check_return_shipment()) { // create an empty record if there is no shipment data
			$this->insert_new_shipment();
		}
		$sql = sprintf("SELECT * FROM %s WHERE order_id = %d", SHIP_ADDRESS, $_SESSION['order_id']);
		if ($result = mysql_query($sql)) {
			$obj = mysql_fetch_object($result);
			$this->ship_name = $obj->name;
			$this->ship_fname = $obj->first_name;
			$this->ship_address = $obj->address;
			$this->ship_pc = $obj->postal_code;
			$this->ship_city = $obj->place;
			$this->ship_country = $obj->country;
			$this->ship_msg = $obj->message;
			$this->ship_email = $obj->email;
			$this->ship_payment = $obj->payment;
			$this->ship_costs = $obj->costs;

		} else {
			$this->error = $this->messages(1);
		}
	}
	// function to insert a new shipment record
	function insert_new_shipment() {


		$sql = sprintf("INSERT INTO %s (order_id, name, first_name, address, postal_code, place, country, message, email, payment, costs) VALUES (%d, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)",


			SHIP_ADDRESS, 
			$_SESSION['order_id'],
			$this->prepare_string_value($this->ship_name), 
			$this->prepare_string_value($this->ship_fname), 
			$this->prepare_string_value($this->ship_address), 
			$this->prepare_string_value($this->ship_pc), 
			$this->prepare_string_value($this->ship_city), 
			$this->prepare_string_value($this->ship_country),
			$this->prepare_string_value($this->ship_msg),
			$this->prepare_string_value($this->ship_email),
			$this->prepare_string_value($this->ship_payment),
			$this->prepare_string_value($this->ship_costs));
		if (!mysql_query($sql)) {
			$this->error = $this->messages(1);
		}
	}
	// insert/update the shipment address vor the current order
	function update_shipment($name, $fname, $address, $postal, $city, $country, $msg, $email, $payment, $costs) {
		if ($this->check_return_shipment()) {
			$sql = sprintf("UPDATE %s SET name = %s, first_name = %s, address = %s, postal_code = %s, place = %s, country = %s, message = %s, email = %s, payment = %s, costs = %s WHERE order_id = %d", 
				SHIP_ADDRESS, 
				$this->prepare_string_value($name),
				$this->prepare_string_value($fname),
				$this->prepare_string_value($address), 
				$this->prepare_string_value($postal), 
				$this->prepare_string_value($city), 
				$this->prepare_string_value($country),
				$this->prepare_string_value($msg),
				$this->prepare_string_value($email),
				$this->prepare_string_value($payment),
				$this->prepare_string_value($costs),
				$_SESSION['order_id']);
			// if (mysql_query($sql)) {
				// $this->error = $this->messages(21);
			// } else {
				// $this->error = $this->messages(1);
			// }
			if (!mysql_query($sql)) {
				$this->error = $this->messages(1);
			}
		}	
	}
	// this method will delete all records for the current order and the visitor is redirect to the main page
	function cancel_order() {
		$err_level = 0;
		if (!mysql_query(sprintf("DELETE FROM %s WHERE order_id = %d", SHIP_ADDRESS, $_SESSION['order_id']))) $err_level++;
		if (!mysql_query(sprintf("DELETE FROM %s WHERE order_id = %d", ORDER_ROWS, $_SESSION['order_id']))) $err_level++;
		if (!mysql_query(sprintf("DELETE FROM %s WHERE id = %d", ORDERS, $_SESSION['order_id']))) $err_level++;
		if ($err_level > 0) {
			$this->error = $this->messages(1);
		} else {
			unset($_SESSION['order_id']);
			header("Location: ".PROD_IDX);
		}	
	}
	// use the property $show_address to show/hide the shipment in the confirmation mail
	function check_out($mailto, $show_address = true) {
		// if($this->pay_costs <> 0)
			// $this->handle_cart_row('FCHQ', 'Frais pour payement par ch&egrave;que', 1, $this->pay_costs);
		$this->set_shipment_data();
		// if($this->ship_costs <> 0)
			// $this->handle_cart_row('FLIV', 'Frais de livraison', 1, $this->ship_costs);

		if ($this->mail_order($mailto, $show_address)) {
			header("Location: ".CONFIRM);die();
		} else {
			$this->error = $this->messages(2);
		}
	}
	function mail_order($to, $show_shipment) { 
		$header = "From: \"".SITE_MASTER."\" <".SITE_MASTER_MAIL.">\r\n";
		$header .= "Cc: ".SITE_MASTER_MAIL."\r\n";
		//$header .= "MIME-Version: 1.0\r\n";
		$header .= "Content-Type: text/html; charset=\"".MAIL_ENCODING."\"\r\n";
		//$header .= "Content-Transfer-Encoding: 7bit\r\n";
		$subject =  $this->messages(51); //your mailsubject incl. current date
		$content = '';//$this->messages(52);  the body begin text
		//$t1=getERow('kwa_htmlelm_config','nocontenu = '' AND title = '' ');
		$this->show_ordered_rows(); // rows in the order_array
		$this->set_shipment_data(); 
		$fraistot=$this->show_total_value();
		$fraispanier=$fraistot;
		$fraistot+=$this->ship_costs;
		switch($this->ship_payment){
		case 'paypal':
			$message_payment_status='Nous vous remercions pour votre commande.</p><p>Vous avez choisi le paiement en ligne. Votre commande vous parviendra dans les 8 jours ouvrables suivants la r&eacute;ception de la confirmation de votre paiement.</p>
				<p>Pour conna&icirc;tre le suivi de votre colis, n\'h&eacute;sitez pas &agrave; appeler le +33 4 50379101 ! Les premi&egrave;res informations seront disponibles dans 24 heures.';
			break;
		case 'cheque_fr':
			$message_payment_status='Nous vous remercions pour votre commande.</p><p>Vous avez choisi le paiement par ch&egrave;que.</p><p><b>IMPRIMEZ</b> ce document et <b>JOIGNEZ-Y VOTRE CHEQUE</b> &agrave; l\'adresse suivante :</p><p class="total">Labo S&amp;P
19 Route de Livron<br />
74100 Vetraz<br />
France</p><p>Votre commande vous parviendra dans les 8 jours ouvrables suivants la r&eacute;ception de votre paiement.<p></p>Pour toute information concernant la validation de votre paiement et utlt&eacute;rieurement le suivi de votre colis, n\'h&eacute;sitez pas &agrave; appeler le +33 4 50379101 ! Les premi&egrave;res informations seront disponibles dans 24 heures ouvr&eacute;s.';
			break;
		case 'cheque':
			$fraistot+=20;
			$message_payment_status='Nous vous remercions pour votre commande.</p><p>Vous avez choisi le paiement par ch&egrave;que.</p><p><b>IMPRIMEZ</b> ce document et <b>JOIGNEZ-Y VOTRE CHEQUE</b> &agrave; l\'adresse suivante :</p><p class="total">Labo S&amp;P
19 Route de Livron<br />
74100 Vetraz<br />
France</p><p>Votre commande vous parviendra dans les 8 jours ouvrables suivants la r&eacute;ception de votre paiement.<p></p>Pour toute information concernant la validation de votre paiement et utlt&eacute;rieurement le suivi de votre colis, n\'h&eacute;sitez pas &agrave; appeler le +33 4 50379101 ! Les premi&egrave;res informations seront disponibles dans 24 heures ouvr&eacute;s.';
		}
		$content.='<html>
		<head>
		<style type="text/css">
			body {  font-family: "Book Antiqua", "Monotype Corsiva"; color: #996600; background-color: #FFFFFF}
			h1 {
				border-left: 5px solid #464646;
				font-family: "trebuchet ms";
				font-size: 24px;
				padding: 0px;
				margin: 0px;
				padding-left: 10px;
				color: #464646;
			}
			h2 {
				border-left: 5px solid #464646;
				color: #29BE0C;
				font-family: verdana;
				font-size: 10px;
				padding: 2px;
				margin: 0px;
				line-height: 14px;
				padding-left: 10px;
				margin-top: 20px;
			}
			#name {
				margin-left:0px;
				margin-right: 150px;
				padding-top: 25px;
				padding-bottom: 25px;
				font-family: "trebuchet ms";
				font-size: 36px;
				color: #29BE0C;
				text-decoration: none;
				height:60px;
				float:left;
			}
			#name a {
				text-decoration: none;
			}
			#logo img{
				margin-top: -64px;
				margin-left: 100px;
				float:left;
			}
			#slogan{
				float:right;
				font-size:26px;
				font-weight: bold;
				padding-top:25px;
				font-style:italic;
				color: #29BE0C;
				background:inherit;
			}
			table.commande th, table.commande td {border-right:1px solid #808000;border-bottom:1px solid #808000;text-align:center;padding:3px;}
			table.commande {border-left:1px solid #808000;border-top:1px solid #808000}
			.total{font-size:1.2em}
		</style>
		</head>
		<body>
		<div id="name">Labo <div id="logo"><img src="http://www.labosp.com/fichiers/style/Public/images/LogoBig2.png" alt="Logo du laboratoire Sant &amp; Plante" /></div></div>
		<div id="slogan">Le naturel notre passion ...<br />la science notre exigence<br /></div>
		<div style="clear: both"></div>
		
		<h1>Confirmation de commande</h1>
		<p>'.$message_payment_status.'</p>
		<h2>Votre commande : </h2>
		<p>N&deg; de commande : '.$_SESSION['order_id'].' &nbsp;- &nbsp;le '.date("j.m.Y").'</p>
		<table class="commande">
		  <tr>
		    <th style="width:50px;">N&deg; art.</th>
		    <th style="width:200px;">Produit</th>
			<th style="width:50px;">Prix</th>
			<th style="width:60px;">Quantit&eacute;</th>
			<th style="width:50px;">Montant</th>
		  </tr>';
		 foreach ($this->order_array as $val) { 
		  $content.='<tr>
		    <td>'.$val['product_id'].'</td>
			<td>'.$val['product_name'].'</td>
			<td>'.$this->format_value($val['price']).'</td>
			<td>'.$val['quantity'].'</td>
			<td>'.$this->format_value($val['price'] * $val['quantity']).'</td>
		  </tr>';
		  } 
		$content.='<tr class="total">
			<td colspan="4">Total du panier : </td>
			<td><b>'.$this->format_value($fraispanier).'</b></td>
		  </tr>';
		$content.='<tr>
			<td>FLIV</td>
			<td colspan="3">Frais de livraison</td>
			<td>'.$this->format_value($this->ship_costs).'</td>
		  </tr>';
		if($this->ship_payment=='cheque')
			$content.='<tr>
			<td>FCHQ</td>
			<td colspan="3">Frais pour payement par ch&egrave;que</td>
			<td>'.$this->format_value(20).'</td>
		  </tr>';
		$content.='<tr class="total">
			<td colspan="4">Total de la commande : </td>
			<td><b>'.$this->format_value($fraistot).'</b></td>
		  </tr>
		</table>
		<hr />
		<h2>Sera livr&eacute;e &agrave; :</h2>
		<p>';
		$content.= $this->ship_name.' '.$this->ship_fname."<br>";
		$content.= $this->ship_address."<br>";
		$content.= $this->ship_pc." ".$this->ship_city."<br>";
		$content.= $this->ship_country.'</p>';

		$content.= ($this->ship_msg != "") ? "<p><b>Message et/ou adresse de facturation : </b><br>".nl2br($this->ship_msg)."</p>" : ""; 
		
		
		switch($this->ship_payment){
		case 'paypal':
			$content.= '<p>Payement : En Ligne</p>';
			break;
		case 'cheque_fr':
			$content.= '<p>Payement : Ch&egraveque (fran&ccedil;ais)</p>';
			break;
		case 'cheque':
			$content.= '<p>Payement : Ch&egraveque (&eacute;tranger)</p>';
		}
		$content.= '<hr /><p>Meilleures salutations, le Laboratoire S&amp;P</p>';
		$content.= '</body></html>';
//$content=html_entity_decode($content,ENT_NOQUOTES);
		// next all order rows
/* 		$body .= $this->messages(56); // the table header
		foreach ($this->order_array as $val) {
			$body .= sprintf("\t%-10s  %-30s  %-20s  %-12s\r\n", $val['quantity'], $val['product_name'], $val['product_id'], $this->format_value($val['price'], false));
		}
		$body .= $this->messages(53); // the total amount
		$body .= $this->messages(54); // the VAT amount
		$body .= ($show_shipment) ? $this->messages(57) : ""; // shipment adres...
		$body .= $this->messages(58); // the message.
		$body .= $this->messages(59); // pay method.
		$body .= $this->messages(55); // kind regards...
 */
		//mailCustom($to, $subject, $body, $header,);		
		// $CMail=@mail($to, $subject, $content, $header);
		
		if (mail($to, $subject, $content, $header)) {
			return true;
		} else {
			return false;
		}
	}
	function close_order() {
		$sql = sprintf("UPDATE %s SET processed_on = NOW(), open = 'n' WHERE id = %d", ORDERS, $_SESSION['order_id']);
		if (mysql_query($sql)) {
			$this->error = $this->messages(22);
			unset($_SESSION['order_id']);
		} else {
			$this->error = $this->messages(1);
		}
	}
	// format a decimal number into an euro amount 
	// $encoding is used for the browser and 
	function format_value($value, $encoding = true) {
		if ($encoding) {
			$curr = (ord(CURRENCY) == "128") ? "&#8364;" : htmlentities(CURRENCY);
		} else {
			$curr= CURRENCY;
		}
		$formatted = $curr." ".number_format($value, 2, ",", ".");
		return $formatted;
	}
	// simple string preperation to prepend SQL injections
	function prepare_string_value($value) {
		$new_value = (!get_magic_quotes_gpc()) ? addslashes($value) : $value;
		$new_value = ($new_value != "") ? "'".trim($new_value)."'" : "''";
		return $new_value;
	}

}
?>