/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.12 $
 * $Date: 2006/02/22 20:06:23 $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2006, Moxiecode Systems AB, All rights reserved.
 */

/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('template', 'en,fr,de,it'); // <- Add a comma separated list of all supported languages

/****
 * Steps for creating a plugin from this template:
 *
 * 1. Change all "template" to the name of your plugin.
 * 2. Remove all the callbacks in this file that you don't need.
 * 3. Remove the popup.htm file if you don't need any popups.
 * 4. Add your custom logic to the callbacks you needed.
 * 5. Write documentation in a readme.txt file on how to use the plugin.
 * 6. Upload it under the "Plugins" section at sourceforge.
 *
 ****/

// Singleton class
var TinyMCE_kwa_init_HTML = {
	/**
	 * Returns information about the plugin as a name/value array.
	 * The current keys are longname, author, authorurl, infourl and version.
	 *
	 * @returns Name/value array containing information about the plugin.
	 * @type Array 
	 */
	getInfo : function() {
		return {
			longname : 'Template plugin',
			author : 'Your name',
			authorurl : 'http://www.yoursite.com',
			infourl : 'http://www.yoursite.com/docs/template.html',
			version : "1.0"
		};
	},

	/**
	 * Gets called when a TinyMCE editor instance gets filled with content on startup.
	 *
	 * @param {string} editor_id TinyMCE editor instance id that was filled with content.
	 * @param {HTMLElement} body HTML body element of editor instance.
	 * @param {HTMLDocument} doc HTML document instance.
	 */
	setupContent : function(editor_id, body, doc) {
		if(tinyMCE.getParam("kwa_init_HTML", false) && tinyMCE.getParam("mode", false) == 'exact'){
			did = tinyMCE.getParam("kwa_init_HTML", false);
			if (did) {
				did2 = did.split(',');
				var inst = tinyMCE.getInstanceById(editor_id);
				tid = parseInt(editor_id.substring(11)) ;
				if (did2[tid] != '') {
					htm = document.getElementById(did2[tid]).innerHTML;
					tinyMCE.execInstanceCommand(editor_id, "mceInsertContent", false, htm, true);
					tinyMCE.handleVisualAid(inst.getBody(), true, inst.visualAid, inst);
					tinyMCE.triggerNodeChange();
				}
			}
		}
	}
};

// Adds the plugin class to the list of available TinyMCE plugins
tinyMCE.addPlugin("kwa_init_html", TinyMCE_kwa_init_HTML);
