/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.12 $
 * $Date: 2006/02/22 20:06:23 $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2006, Moxiecode Systems AB, All rights reserved.
 */

/* Import plugin specific language pack */
//tinyMCE.importPluginLanguagePack('kwaforms', 'en,tr,he,nb,ru,ru_KOI8-R,ru_UTF-8,nn,fi,cy,es,is,pl'); // <- Add a comma separated list of all supported languages
tinyMCE.importPluginLanguagePack('kwaforms', 'en,fr'); // <- Add a comma separated list of all supported languages

/****
 * Steps for creating a plugin from this kwaforms:
 *
 * OK 1. Change all "kwaforms" to the name of your plugin. 
 * 2. Remove all the callbacks in this file that you don't need.
 * 3. Remove the popup.htm file if you don't need any popups.
 * 4. Add your custom logic to the callbacks you needed.
 * 5. Write documentation in a readme.txt file on how to use the plugin.
 * 6. Upload it under the "Plugins" section at sourceforge.
 *
 ****/

// Singleton class
var TinyMCE_kwaformsPlugin = {
	/**
	 * Returns information about the plugin as a name/value array.
	 * The current keys are longname, author, authorurl, infourl and version.
	 *
	 * @returns Name/value array containing information about the plugin.
	 * @type Array 
	 */
	getInfo : function() {
		return {
			longname : 'kwaforms plugin',
			author : 'Benjamin Keller',
			authorurl : 'http://www.concept-info.ch',
			infourl : 'http://www.concept-info.ch',
			//infourl : 'http://www.yoursite.com/docs/kwaforms.html',
			version : "1.0"
		};
	},
	getControlHTML : function(control_name) {
		var controls = new Array(
			['kwaform', 'form.gif', 'lang_kwaforms_desc', 'mcekwaforms', true],
			['kwatextinput', 'text.gif', 'lang_kwaformsinput_desc', 'mcekwaformsTxtInput', true],
			['kwapassinput', 'password.gif', 'lang_kwaformspass_desc', 'mcekwaformsPassInput', true],
			['kwahiddeninput', 'hidden.gif', 'lang_kwaformshidden_desc', 'mcekwaformsHiddenInput', true],
			['kwatextarea', 'textarea.gif', 'lang_kwaformstextarea_desc', 'mcekwaformsTxtArea', true],
			['kwachechkbox', 'checkbox.gif', 'lang_kwaformscheckb_desc', 'mcekwaformsCheckbox', true],
			['kwaradio', 'radio.gif', 'lang_kwaformsradio_desc', 'mcekwaformsRadio', true],
			['kwaselect', 'select.gif', 'lang_kwaformsselect_desc', 'mcekwaformsSelect', true],
			['kwaboutton', 'boutton1.gif', 'lang_kwaformsboutton_desc', 'mcekwaformsButton', true]);

		// Render table control
		for (var i=0; i<controls.length; i++) {
			var but = controls[i];
			var cmd = 'tinyMCE.execInstanceCommand(\'{$editor_id}\',\'' + but[3] + '\', ' + (but.length > 4 ? but[4] : false) + (but.length > 5 ? ', \'' + but[5] + '\'' : '') + ');return false;';

			if (but[0] == control_name)
				return tinyMCE.getButtonHTML(control_name, but[2], '{$pluginurl}/images/'+ but[1], but[3], (but.length > 4 ? but[4] : false));
		}

		// Special tablecontrols
		if (control_name == "kwaforms") {
			var html = "";

			html += tinyMCE.getControlHTML("kwaform");
			html += tinyMCE.getControlHTML("separator");
			html += tinyMCE.getControlHTML("kwatextinput");
			html += tinyMCE.getControlHTML("kwahiddeninput");
			html += tinyMCE.getControlHTML("kwapassinput");
			html += tinyMCE.getControlHTML("kwaselect");
			html += tinyMCE.getControlHTML("kwatextarea");
			html += tinyMCE.getControlHTML("kwachechkbox");
			html += tinyMCE.getControlHTML("kwaradio");
			html += tinyMCE.getControlHTML("kwaboutton");

			return html;
		}

		return "";
	},
	handleVisualAid : function(el, deep, state, inst) {
		var nl = inst.getDoc().getElementsByTagName("form"), i;

		for (i=0; i<nl.length; i++) {
			if (state)
				tinyMCE.addCSSClass(nl[i], 'mceVisualAid');
			else
				tinyMCE.removeCSSClass(nl[i], 'mceVisualAid');					
		}
		var nl = inst.getDoc().getElementsByTagName("input"), i;

		for (i=0; i<nl.length; i++) {
			if (nl2 = tinyMCE.getParentElement(nl[i], "INPUT", "type", "hidden")) {
				if (state)
					tinyMCE.addCSSClass(nl2, 'mceVisualAid');
				else
					tinyMCE.removeCSSClass(nl2, 'mceVisualAid');					
			}
		}
	},
	execCommand : function(editor_id, element, command, user_interface, value) {
		var template = new Array();
		//if (user_interface) {alert(command);}

		template['file'] = 't';  //Relative to theme
		if (command == "mcekwaforms")
			template['file'] = '../../plugins/kwaforms/popup.htm';

		if (command == "mcekwaformsTxtInput")
			template['file'] = '../../plugins/kwaforms/input.htm';

		if (command == "mcekwaformsPassInput")
			template['file'] = '../../plugins/kwaforms/password.htm';

		if (command == "mcekwaformsHiddenInput")
			template['file'] = '../../plugins/kwaforms/hidden.htm';

		if (command == "mcekwaformsTxtArea")
			template['file'] = '../../plugins/kwaforms/textarea.htm';

		if (command == "mcekwaformsCheckbox")
			template['file'] = '../../plugins/kwaforms/checkbox.htm';

		if (command == "mcekwaformsRadio")
			template['file'] = '../../plugins/kwaforms/radio.htm';

		if (command == "mcekwaformsSelect")
			template['file'] = '../../plugins/kwaforms/select.htm';
		
		if (command == "mcekwaformsButton")
			template['file'] = '../../plugins/kwaforms/boutton.htm';

		template['width'] = 300;
		template['height'] = 200;
		if (user_interface && template['file'] != 't') {
				//alert(command);
				tinyMCE.openWindow(template, {editor_id : editor_id, some_custom_arg : "somecustomdata"});
				return true;
//				alert('test');
		} else {
		// Pass to next handler in chain
			return false;
		}
	},
	handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		// Select abbr button if parent node is a strong or b
		var inst = tinyMCE.getInstanceById(editor_id);
		var elm = inst.getFocusElement();
		fid = tinyMCE.getParentElement(elm, "FORM");
		iptid = tinyMCE.getParentElement(elm, "INPUT", "type", "text");
		ihid = tinyMCE.getParentElement(elm, "INPUT", "type", "hidden");
		ipid = tinyMCE.getParentElement(elm, "INPUT", "type", "password");
		irid = tinyMCE.getParentElement(elm, "INPUT", "type", "radio");
		icid = tinyMCE.getParentElement(elm, "INPUT", "type", "checkbox");
		b1id = tinyMCE.getParentElement(elm, "INPUT", "type", "submit");
		b2id = tinyMCE.getParentElement(elm, "INPUT", "type", "reset");
		b3id = tinyMCE.getParentElement(elm, "INPUT", "type", "button");
		txid = tinyMCE.getParentElement(elm, "TEXTAREA");
		seid = tinyMCE.getParentElement(elm, "SELECT");
		tinyMCE.switchClass(editor_id + '_kwatextinput', 'mceButtonDisabled');
		tinyMCE.switchClass(editor_id + '_kwapassinput', 'mceButtonDisabled');
		tinyMCE.switchClass(editor_id + '_kwahiddeninput', 'mceButtonDisabled');
		tinyMCE.switchClass(editor_id + '_kwatextarea', 'mceButtonDisabled');
		tinyMCE.switchClass(editor_id + '_kwachechkbox', 'mceButtonDisabled');
		tinyMCE.switchClass(editor_id + '_kwaradio', 'mceButtonDisabled');
		tinyMCE.switchClass(editor_id + '_kwaselect', 'mceButtonDisabled');
		tinyMCE.switchClass(editor_id + '_kwaboutton', 'mceButtonDisabled');
		var selectedKWACtrl = '';
		if (fid) {
			tinyMCE.switchClass(editor_id + '_kwaform', 'mceButtonSelected');
			selectedKWACtrl = 'possible';
		} else 
			tinyMCE.switchClass(editor_id + '_kwaform', 'mceButtonNormal');
		if (iptid) {
			tinyMCE.switchClass(editor_id + '_kwatextinput', 'mceButtonSelected');
			selectedKWACtrl = 'on';
		}
		if (ipid) {
			tinyMCE.switchClass(editor_id + '_kwapassinput', 'mceButtonSelected');
			selectedKWACtrl = 'on';
		}
		if (ihid) {
			tinyMCE.switchClass(editor_id + '_kwahiddeninput', 'mceButtonSelected');
			selectedKWACtrl = 'on';
		}
		if (txid) {
			tinyMCE.switchClass(editor_id + '_kwatextarea', 'mceButtonSelected');
			selectedKWACtrl = 'on';
		}
		if (icid) {
			selectedKWACtrl = 'on';
			tinyMCE.switchClass(editor_id + '_kwachechkbox', 'mceButtonSelected');
		}
		if (irid) {
			tinyMCE.switchClass(editor_id + '_kwaradio', 'mceButtonSelected');
			selectedKWACtrl = 'on';
		}
		if (seid) {
			tinyMCE.switchClass(editor_id + '_kwaselect', 'mceButtonSelected');
			selectedKWACtrl = 'on';
		}
		if (b1id || b2id || b3id) {
			tinyMCE.switchClass(editor_id + '_kwaboutton', 'mceButtonSelected');
			selectedKWACtrl = 'on';
		}
if (selectedKWACtrl == 'possible') {
			tinyMCE.switchClass(editor_id + '_kwatextinput', 'mceButtonNormal');
			tinyMCE.switchClass(editor_id + '_kwapassinput', 'mceButtonNormal');
			tinyMCE.switchClass(editor_id + '_kwahiddeninput', 'mceButtonNormal');
			tinyMCE.switchClass(editor_id + '_kwatextarea', 'mceButtonNormal');
			tinyMCE.switchClass(editor_id + '_kwachechkbox', 'mceButtonNormal');
			tinyMCE.switchClass(editor_id + '_kwaradio', 'mceButtonNormal');
			tinyMCE.switchClass(editor_id + '_kwaselect', 'mceButtonNormal');
			tinyMCE.switchClass(editor_id + '_kwaboutton', 'mceButtonNormal');
		}
		return true;

		// Deselect abbr button
		//tinyMCE.switchClass(editor_id + '_abbr', 'mceButtonNormal');
	}


};

// Adds the plugin class to the list of available TinyMCE plugins
tinyMCE.addPlugin("kwaforms", TinyMCE_kwaformsPlugin);
