<?php
/**
 * Cette class regroupe plusieurs fonctions utilise dans des scripts php,
 * adaptation du fichier de fonctions 'mcc-fonctions.php'.
 * !  Une connexion sur la Base de donnes doit tre ouverte pour certaines fonctions.  !
 * @name MCCLib
 * @package MCC-Librairy
 * @version 0.47
 * @author Martin Coste
 * @link http://www.mc-concept.ch/contact.html
 * @copyright 2007 MC-Concept.ch
 */
class MCCLib {

 /**
  * Tableau des mois en franais
  * @access public
  * @var array $arr_moisfr
 */
 public $arr_moisfr=array('zero',
               'Janvier',
               'Fvrier',
               'Mars',
               'Avril',
               'Mai',
               'Juin',
               'Juillet',
               'Aot',
               'Septembre',
               'Octobre',
               'Novembre',
               'Dcembre');

 /**
  * Tableau des jours en franais
  * @access public
  * @var array $arr_jourfr
 */
 public $arr_jourfr=array('zero',
               'lundi',
               'mardi',
               'mercredi',
               'jeudi',
               'vendredi',
               'samedi',
               'dimanche');

 /**
  * Tableau des correspondances des jours 'anglais'=>'franais'
  * @access public
  * @var array $arr_moisfr
 */
 public $arr_jouren2fr=array(
               "Monday" => "lundi",
               "Tuesday" => "mardi",
               "Wednesday" => "mercredi",
               "Thursday" => "jeudi",
               "Friday" => "vendredi",
               "Saturday" => "samedi",
               "Sunday" => "dimanche");

 /**
  * Altrne deux valeurs, $color1 et $color2, permet d'altrner les couleurs de fond dans des listes.
  * Utilise une variable de type 'static' pour garder la valeur de l'appel prcdant.
  * Exemple:
  * <code>
  * <table>
  *  <tr bgcolor="<?php echo MCCLib::Changecolor('#f5f5f5','#faf0e6') ?>" ><td>1 couleur 1</td></tr>
  *  <tr bgcolor="<?php echo MCCLib::Changecolor('#f5f5f5','#faf0e6') ?>" ><td>2 couleur 2</td></tr>
  *  <tr bgcolor="<?php echo MCCLib::Changecolor('#f5f5f5','#faf0e6') ?>" ><td>3 couleur 1</td></tr>
  * etc...
  * </code>
  * @param string $color1 couleur 1, #ff0000
  * @param string $color2 couleur 2, #0000ff
  * @return string la valeur de $color1 ou $color2
 */
 public function Changecolor($color1,$color2) {
  static $col;
  if ($col==$color1) {$col=$color2;} else {$col=$color1;}
  return $col;
 }

 /**
  * Retourne tout array() php sous forme de code HTML avec des 'ul' 'li' pour une meilleur visualisation
  * supporte les tableaux imbriqus, array(array(array()))
  * @param array $tab tableau
  * @return string la balise 'ul' complte
 */
 public function Aff_tab($tab){
  if(is_array($tab)) {
   echo "<ul>";
   foreach($tab AS $cle=>$val){
    if($val=="") $val="NULL";
    if(!is_array($val)){echo "<li>[$cle] => $val</li>";} else {echo "<li>[$cle] ==> </li>"; Aff_tab($val);}
   }
   echo "</ul>";
  }
 }

 /**
  * Retourne les arguments 'width="xx" height="yy"' d'un fichier images pour tre insr dans une balise HTML 'img'
  * @param string $file nom du fichier avec son chemin absolu ou relatif.
  * @return string les arguments 'width="xx" height="yy"'
 */
 public function GET_ImgSize($file) {
  if (@getimagesize($file)) {
   $tb_img=getimagesize($file);
   return $tb_img['3'];
  }
 }

 /**
  * Ouvre une connexion sur un serveur MySQL
  * en cas d'erreur affiche:
  * <code>"<p>Erreur MySQL: Connexion au serveur <b>$server</b> impossible...</p>"</code>
  * @param string $server nom d'hte du serveur
  * @param string $user nom d'utilisateur
  * @param string $pass mot de passe
  * @return integer l'identifiant de connexion MySQL en cas de succs
 */
 public function DB_connect($server,$user,$pass){
  $db_connect=mysql_connect($server,$user,$pass);
  if (!$db_connect) {echo "<p>Erreur MySQL: Connexion au serveur <b>$server</b> impossible...</p>";}
  return $db_connect;
 }

 /**
  * Slectionne une base de donnes MySQL
  * en cas d'erreur affiche:
  * <code>"<p>Erreur MySQL: Slection de la base de donnes <b>$dbase</b> impossible...</p><p>".mysql_error()."</p>"</code>
  * @param string $dbase nom de la base de donnes
  * @param string $id_user l'identifiant de connexion retourn par DB_connect()
  * @return boolean TRUE en cas de succs, FALSE en cas d'chec
 */
 public function DB_select($dbase,$id_user){
  if (!mysql_select_db($dbase,$id_user)) {
   echo"<p>Erreur MySQL: Slection de la base de donnes <b>$dbase</b> impossible...</p><p>".mysql_error()."</p>";
   mysql_close($id_user);
   exit;
  }
 }

 /**
  * Excute une requte sur une base de donnes MySQL
  * en cas d'erreur affiche:
  * <code>"<p>DB_result: Impossible d'effectuer la requte...<br />$req<br />Erreur MySQL : ".mysql_error()."</p>"</code>
  * @param string $req requte MySQL
  * @param string $id_user l'identifiant de connexion retourn par DB_connect()
  * @return resource un identifiant de connexion MySQL
 */
 public function DB_result($req,$id_user){
  $res=mysql_query($req,$id_user);
  if (!$res) {
   echo "<p>Erreur MySQL: Impossible d'effectuer la requte...<br />$req</p><p>".mysql_error()."</p>";
   mysql_close($id_user);
   exit;
  } else {return $res;}
 }

 /**
  * Retourn la liste des Base de Donnes sur un serveur
  * !  Une connexion sur la Base de donnes doit tre ouverte.  !
  * @return array un tableau des Base de Donnes
 */
 public function DB_Liste($prefix="") {
  if($prefix=="") $res=mysql_query("show databases");
  $res=mysql_query("show databases");
  $rows=mysql_num_rows($res);
  $liste=array();
  while ($row=mysql_fetch_row($res)) {array_push($liste,$row[0]);}
  return $liste;
 }

 /**
  * Retourne la date du jour suivant au format MySQL 'yyyy-mm-jj'
  * Exemple:
  * <code>
  * <?php echo MCCLib::Date_Plus('2004-02-28') ?>
  * </code>
  * @param string $jour la date '2007-02-28'
  * @return string la date plus un jour, '2004-02-29'
 */
function Date_Plus($jour){
 $tab=explode("-",$jour);
 if(is_array($tab) && isset($tab[2])) {
  $tab[2]++;
  $jour=date("Y-m-d",mktime(0,0,0,$tab[1],$tab[2],$tab[0]));
 }
 return $jour;
}

 /**
  * Retourne la date du jour d'avant au format MySQL 'yyyy-mm-jj'
  * Exemple:
  * <code>
  * <?php echo MCCLib::Date_Moins('2004-03-01') ?>
  * </code>
  * @param string $jour la date '2004-03-01'
  * @return string la date moins un jour, '2004-02-29'
 */
function Date_Moins($jour){
 $tab=explode("-",$jour);
 if(is_array($tab) && isset($tab[2])) {
  $tab[2]--;
  $jour=date("Y-m-d",mktime(0,0,0,$tab[1],$tab[2],$tab[0]));
 }
 return $jour;
}

 /**
  * Fonction qui retourne le numro de la semaine par rapport a une date
  * Norme ISO-8601:
  * - La semaine 1 de toute anne est celle qui contient le 4 janvier ou
  *   que la semaine 1 de toute anne est celle qui contient le 1er jeudi de janvier
  * - La majorit des annes ont 52 semaines mais les annes qui commence un jeudi et
  *   les annes bissextiles commenant un mercredi en possde 53
  * - Le 1er jour de la semaine est le Lundi
  * Exemple:
  * <code><?php $week=MCCLib::Date_GetWeek(date("j"),date("m"),date("Y")); ?></code>
  * @author Thomas Pequet - webmaster@memotoo.com
  * @link http://www.memotoo.com
  * @param integer $jour Jour
  * @param integer $mois Mois
  * @param integer $annee Anne
  * @return integer numro de semaine
  */
 function Date_GetWeek($jour,$mois,$annee) {
  // Dfinition du Jeudi de la semaine
  if (date("w",mktime(12,0,0,$mois,$jour,$annee))==0)      // Dimanche
      $jeudiSemaine = mktime(12,0,0,$mois,$jour,$annee)-3*24*60*60;
  else if (date("w",mktime(12,0,0,$mois,$jour,$annee))<4)  // du Lundi au Mercredi
      $jeudiSemaine = mktime(12,0,0,$mois,$jour,$annee)+(4-date("w",mktime(12,0,0,$mois,$jour,$annee)))*24*60*60;
  else if (date("w",mktime(12,0,0,$mois,$jour,$annee))>4)  // du Vendredi au Samedi
      $jeudiSemaine = mktime(12,0,0,$mois,$jour,$annee)-(date("w",mktime(12,0,0,$mois,$jour,$annee))-4)*24*60*60;
  else $jeudiSemaine = mktime(12,0,0,$mois,$jour,$annee);  // Jeudi

  // Dfinition du premier Jeudi de l'anne
  if (date("w",mktime(12,0,0,1,1,date("Y",$jeudiSemaine)))==0){       // Dimanche
      $premierJeudiAnnee = mktime(12,0,0,1,1,date("Y",$jeudiSemaine))+4*24*60*60;}
  else if (date("w",mktime(12,0,0,1,1,date("Y",$jeudiSemaine)))<4){   // du Lundi au Mercredi
      $premierJeudiAnnee = mktime(12,0,0,1,1,date("Y",$jeudiSemaine))+(4-date("w",mktime(12,0,0,1,1,date("Y",$jeudiSemaine))))*24*60*60;
  } else if (date("w",mktime(12,0,0,1,1,date("Y",$jeudiSemaine)))>4){ // du Vendredi au Samedi
      $premierJeudiAnnee = mktime(12,0,0,1,1,date("Y",$jeudiSemaine))+(7-(date("w",mktime(12,0,0,1,1,date("Y",$jeudiSemaine)))-4))*24*60*60;
  } else {$premierJeudiAnnee = mktime(12,0,0,1,1,date("Y",$jeudiSemaine));}// Jeudi

  // Dfinition du numro de semaine: nb de jours entre "premier Jeudi de l'anne" et "Jeudi de la semaine";
  $numeroSemaine = ((date("z",mktime(12,0,0,date("m",$jeudiSemaine),date("d",$jeudiSemaine),date("Y",$jeudiSemaine)))
                        -
                     date("z",mktime(12,0,0,date("m",$premierJeudiAnnee),date("d",$premierJeudiAnnee),date("Y",$premierJeudiAnnee)))) / 7
                   ) + 1;
  // Cas particulier de la semaine 53
  if ($numeroSemaine==53){
   // Les annes qui commence un Jeudi et les annes bissextiles commenant un Mercredi en possde 53
   if (date("w",mktime(12,0,0,1,1,date("Y",$jeudiSemaine)))==4 ||
      (date("w",mktime(12,0,0,1,1,date("Y",$jeudiSemaine)))==3 &&
       date("z",mktime(12,0,0,12,31,date("Y",$jeudiSemaine)))==365))
   {$numeroSemaine = 53;} else {$numeroSemaine = 1;}
  }
  //echo $jour."-".$mois."-".$annee." (".date("d-m-Y",$premierJeudiAnnee)." - ".date("d-m-Y",$jeudiSemaine).") -> ".$numeroSemaine."<BR>";
  return sprintf("%02d",$numeroSemaine);
 }

 /**
  * Retourne la date du jour en franais ou traduit la date complte d'anglais  franais
  * Exemple pour la date du jour:
  * <code>
  * <?php echo MCCLib::Date_complFR() ?>
  * </code><br />
  * Exemple pour traduire une date:
  * <code>
  * <?php echo MCCLib::Date_complFR('Tuesday','24','8','2007') ?>
  * </code>
  * @param string $joursem le jour de la semaine
  * @param string $jour le jour
  * @param string $mois le mois
  * @param string $annee l'anne
  * @return string la date complte en franais, 'vendredi 24 aot 2007'
 */
 public function Date_complFR($joursem="",$jour="",$mois="",$annee=""){
  $arr_moisfr=array('zero','janvier','fvrier','mars','avril','mai','juin','juillet','aot','septembre','octobre','novembre','dcembre');
  $arr_jouren2fr=array("Monday"=>"lundi","Tuesday"=>"mardi","Wednesday"=>"mercredi","Thursday"=>"jeudi",
                       "Friday"=>"vendredi","Saturday"=>"samedi","Sunday"=>"dimanche");
  if($joursem=="" OR $jour=="" OR $mois=="" OR $annee=="") {$joursem=date('l');$jour=date('j');$mois=date('m');$annee=date('Y');}
  $res="";
  foreach($arr_jouren2fr as $j_en => $j_fr){if($joursem==$j_en){$res.=$j_fr;}}
  $res.=" $jour ";
  foreach($arr_moisfr as $m_en => $m_fr){if($mois==$m_en){$res.=$m_fr;}}
  $res.=" $annee";
  return $res;
 }

 /**
  * Convertit une date MySQL 'yyyy-mm-dd' en date complte en franais
  * Exemple:
  * <code>
  * <?php echo MCCLib::Date_mysql2complFR('2007-08-24') ?>
  * </code>
  * @param string $mydate date MySQL
  * @return string date complte 'vendredi 24 aot 2007'
 */
 public function Date_mysql2complFR($mydate){
  $tab=explode("-",$mydate);
  if(is_array($tab) && isset($tab[2])) {
   $jour_ang=date("l-d-m-Y",mktime(0,0,0,$tab[1],$tab[2],$tab[0]));
   $day=explode("-",$jour_ang);
   $date=self::Date_complFR($day[0],$day[1],$day[2],$day[3]);
   return $date;
  } else return $mydate;
 }

 /**
  * Retourne la date et l'heure de dernire modification d'un fichier
  * Exemple, rcuprer la date et la traduire avec Date_complFR():
  * <code>
  * <?php
  * $tmp=explode(" ",MCCLib::Date_MajFile(__FILE__));
  * echo MCCLib::Date_complFR($tmp[0],$tmp[1],$tmp[2],$tmp[3])."  ".$tmp[4];
  * ?>
  * </code>
  * @param string $file nom du fichier avec son chemin absolu ou relatif.
  * @return string la date et l'heure, 'Monday 16 08 2007 16:08:07'
 */
 function Date_MajFile($file) {
  $file=basename($file);
  $f_joursem=date ('l', filemtime($file));
  $f_jour=date ('j', filemtime($file));
  $f_mois=date ('m', filemtime($file));
  $f_annee=date ('Y', filemtime($file));
  $f_heure=date ('G:i:s', filemtime($file));
  $res=$f_joursem." ".$f_jour." ".$f_mois." ".$f_annee." ".$f_heure;
  return $res;
 }

 /**
  * Rcupre la liste des valeurs setes dans un champ MySQL de type 'enum'
  * Exemple:
  * <code>
  * <?php $listenum=MCCLib::SQL_get_enum_values($table,$champ) ?>
  * </code>
  * !  Une connexion sur la Base de donnes doit tre ouverte.  !
  * @param string $table table source
  * @param string $champ nom du champ enum()
  * @return array un tableau des enum()
 */
 function SQL_get_enum_values($table,$champ){

  function _parse_enum_result($enum_result){
   preg_match_all("/'(.*?)'/", $enum_result, $matches);
   return $matches[1];
  }

  $req="SHOW COLUMNS FROM $table LIKE '$champ'";
  $res=mysql_query($req);
  if ($res){
   list($junk,$enum_values)=mysql_fetch_row($res);
   return _parse_enum_result($enum_values);
  } else {return "";}
 }


 /**
  * Cre une balise HTML <select> avec le rsultat d'un 'SELECT DISTINCT $champ FROM $table WHERE $wchamp=$wvalue ORDER BY $obchamp'
  * Exemple:
  * <code>
  * <?php echo MCCLib::SQL_Distinct2Select($table,$champ,$wchamp,$wvalue,$obchamp,$snom,$sid,$sselected,0," onclick='PostValue()'") ?>
  * </code>
  * !  Une connexion sur le serveur doit tre ouverte.  !
  * @param string $table table source
  * @param string $champ nom du champ DISTINCT
  * @param string $wchamp nom du champ WHERE
  * @param string $wvalue valeur du WHERE
  * @param string $obchamp nom du champ ORDER BY
  * @param string $snom argument 'name' du <select>
  * @param string $sid argument 'id' du <select>
  * @param string $sselected valeur 'selected' du <select>
  * @param boolean $sblanc True: ajout d'une ligne vide avec la valeur '-1' au dbut du <select>
  * @param string $sjscript ajout d'une action JScript  la balise <select>
  * @return string la balise <select>...</select> complte
 */
 function SQL_Distinct2Select($table,$champ,$wchamp,$wvalue,$obchamp,$snom,$sid,$sselected,$sblanc=0,$sjscript=""){
  $where="";
  $orderby="";
  if(strlen($wchamp)>1 && strlen($wvalue)>1) $where="WHERE $wchamp='$wvalue'";
  if(strlen($obchamp)>1) $orderby="ORDER BY $obchamp";
  $req="SELECT DISTINCT $champ FROM $table $where $orderby";
  $res=mysql_query($req);
  $slct="<select id='$sid' class='col_beige' name='$snom' $sjscript>";
  if($sblanc){
   $slct.="<option value='-1'";
   if ($sselected<0) $slct.=" selected='selected'";
   $slct.="></option>";
  }
  while($tmp=mysql_fetch_array($res)){
   $slct.="<option value='$tmp[0]'";
   if ($tmp[0]==$sselected) $slct.=" selected='selected'";
   $slct.=">$tmp[0]</option>";
  }
  $slct.="</select>";
  return $slct;
 }

}