<?php
/**
 * Cette class gnre et enregistre les informations relatives
 * aux visiteurs et  leurs parcours sur un site web
 * Les donnes sont stockes dans deux tables MySQL, une pour les visiteurs et une pour les pages vues.
 * !  Une connexion sur la Base de donnes doit tre ouverte.  !
 * @name MCCVisitors
 * @package MCC-WebStats
 * @version 0.47
 * @author Martin Coste
 * @link http://www.mc-concept.ch/contact.html
 * @copyright 2007 MC-Concept.ch
 */
class MCCVisitors {

 /**
  * Nom de la table des 'visiteurs'
  * @access public
  * @var string $DBVisiteur
  * @defvalue stats_visiteur
 */
 public $DBVisiteur='stats_visiteur';

 /**
  * Nom de la table des 'pages vues'
  * @access public
  * @var string $DBVisite
  * @defvalue stats_visite
 */
 public $DBVisite='stats_visite';

 /**
  * Adresse IP du visiteur
  * @access public
  * @var string $IP
 */
 public $IP="";

 /**
  * Port de connexion du visiteur
  * @access public
  * @var string $Port
 */
 public $Port="";

 /**
  * Adresse DNS du visiteur
  * @access public
  * @var string $Hostname
 */
 public $Hostname="";

 /**
  * Agent du visiteur, la signature complte du navigateur
  * @access public
  * @var string $Agent
 */
 public $Agent="";

 /**
  * Rfrence du visiteur, adresse de l'origine de la requte
  * @access public
  * @var string $Referant
 */
 public $Referer="";

 /**
  * Requte du visiteur, l'URL demande
  * @access public
  * @var string $Request
 */
 public $Request="";

 /**
  * Pays du point d'accs du visiteur, nom en franais
  * @access public
  * @var string $Pays
 */
 public $Pays="";

 /**
  * Ville du point d'accs du visiteur
  * @access public
  * @var string $Ville
 */
 public $Ville="";

 /**
  * Latitude de la Ville du point d'accs
  * @access public
  * @var decimal(6.4) $Latitude
 */
 public $Latitude=00.0000;

 /**
  * Longitude de la Ville du point d'accs
  * @access public
  * @var decimal(7.4) $Longitude
 */
 public $Longitude=000.0000;

 /**
  * Systme d'exploitation utilis par le visiteur
  * @access public
  * @var string $OS
 */
 public $OS="";

 /**
  * Navigateur utilis par le visiteur
  * @access public
  * @var string $Browser
 */
 public $Browser="";

 /**
  * Langues acceptes par le navigateur du visiteur, contient la valeur renvoye par getenv('HTTP_ACCEPT_LANGUAGE')
  * @access public
  * @var string $BrowserLang
 */
 public $BrowserLang="";

 /**
  * Tableau des langues acceptes par le navigateur du visiteur, tries par prfrence
  * @example 'fr-ch'=>'Franais (Suisse)'
  * @access public
  * @var array $ArrayLang
 */
 public $ArrayLang=array();

 /**
  * Titre de la page visite, par defaut on prend le nom du fichier transmis au visiteur
  * @access public
  * @var string $TitrePage
 */
 public $TitrePage="";

 /**
  * Nouveau visiteur, le test se base sur l'adresse IP, le USER_AGENT et la date pour chercher si il est dj venu aujourd'hui.
  * @access public
  * @var boolean $ItsNew
  * @defvalue True
 */
 public $ItsNew=True;

 /**
  * Numro du visiteur, si il est dj venu aujourd'hui, sert de clef pour les enregistrements des visites
  * @access public
  * @var integer $NoVisiteur
 */
 public $NoVisiteur=0;


 /**#@+
  * MTxxx, microtime() interne
  * @access public
  * @var integer
 */
 public $MTregion=0;
 public $MTconstruct=0;
 public $MThostname=0;
 public $MTsys=0;
 public $MTrecup=0;
/**#@-*/


 /**
  * Retourne le navigateur du visiteur d'aprs $_SERVER['HTTP_USER_AGENT']
  * Exemple:
  * <code> <?php $browser=$Visiteur-&gt;Client_Browser($agent); ?> </code>
  * @param string $agent l'agent du visiteur
  * @return string le navigateur
 */
  public function Client_Browser($agent) {
   if ($agent=="") {$c_brw="Navigateur masqu";}
   elseif (eregi("Firefox", $agent)) {
    if (eregi("Firefox/0.8", $agent)) {$c_brw="Firefox 0.8";}
    elseif (eregi("Firefox/1.0", $agent)) {$c_brw="Firefox 1.0";}
    elseif (eregi("Firefox/1.5", $agent)) {$c_brw="Firefox 1.5";}
    elseif (eregi("Firefox/2", $agent)) {$c_brw="Firefox 2";}
    else {$c_brw="Firefox";}
   }
   elseif (eregi("Java/1.4.2",$agent)) {$c_brw="Java 1.4.2";}
   elseif (eregi("Netscape/",$agent)) {
    if (eregi("Netscape/7.",$agent)) {$c_brw="Netscape 7";}
     else {$c_brw="Netscape";}
   }
   elseif (eregi("Camino/1.", $agent)) {$c_brw="Camino 1";}
   elseif (eregi("Konqueror",$agent)) {$c_brw="Konqueror";}
   elseif (eregi("OffByOne",$agent)) {$c_brw="OffByOne";}
   elseif (eregi("Opera",$agent)||eregi("Opra",$agent)) {
    if (eregi("6.",$agent)) {$c_brw="Opra 6";}
    elseif (eregi("7.",$agent)) {$c_brw="Opra 7";}
    elseif (eregi("8.",$agent)) {$c_brw="Opra 8";}
    elseif (eregi("9.",$agent)) {$c_brw="Opra 9";}
    else {$c_brw="Opra";}
   }
   elseif (eregi("Lynx",$agent)) {
    if (eregi("/2.8.5",$agent)) {$c_brw="Lynx-2.8.5";}
    else {$c_brw="Lynx";}
   }
   elseif (eregi("Safari",$agent)) {$c_brw="Safari";}
   elseif (eregi("Notepad Pro 1.0",$agent)) {$c_brw="Notepad Pro 1.0";}

   elseif (eregi("MSIE",$agent)) {
    if (eregi("MSIE 7.0",$agent)) {$c_brw="Internet Explorer 7.0";}
     elseif (eregi("MSIE 6.0",$agent)) {$c_brw="Internet Explorer 6.0";}
     elseif (eregi("MSIE 5.5",$agent)) {$c_brw="Internet Explorer 5.5";}
     elseif (eregi("MSIE 5.1",$agent)) {$c_brw="Internet Explorer 5.1";}
     elseif (eregi("MSIE 5.0",$agent)||eregi("MSIE 5.00",$agent)||eregi("MSIE 5.01",$agent)) {$c_brw="Internet Explorer 5.0";}
     elseif (eregi("MSIE 4.5",$agent)) {$c_brw="Internet Explorer 4.5";}
     elseif (eregi("MSIE 4.0",$agent)||eregi("MSIE 4.01",$agent)) {$c_brw="Internet Explorer 4.0";}
      else {$c_brw="Internet Explorer";}
   }
//   elseif (eregi("Mozilla/3.0 (compatible)",$agent)) {$c_brw="Rippers";}
   elseif (eregi("Mozilla/4.0",$agent)) {
    if (eregi("WinHttpRequest",$agent)) {$c_brw="WinHttpRequest";}
    else {$c_brw="Netscape 4.0";}
   }
   elseif (eregi("Mozilla/4.5",$agent)) {$c_brw="Netscape 4.5";}
   elseif (eregi("Mozilla/4.7",$agent)) {$c_brw="Netscape 4.7";}
   elseif (eregi("Mozilla/5.0",$agent)) {
    if (eregi("Macintosh",$agent) && eregi("Safari",$agent)) {$c_brw="Safari";}
    else {$c_brw="Mozilla 5.0";}
   }
   else {$c_brw="Navigateur inconnu";}

   if ($agent=="Mozilla/3.01 (compatible;)") {$c_brw="Robot MysteryBot";}
   elseif (eregi("W3C_Validator",$agent)) {$c_brw="W3C Validator";}
   elseif (eregi("W3C_CSS_Validator",$agent)) {$c_brw="W3C CSS Validator";}
   elseif (eregi("AcadiaUniversity",$agent)) {$c_brw="Robot Acadiau.ca";}
   elseif (eregi("Accoona-AI-Agent",$agent)) {$c_brw="Robot Accoona.com";}
   elseif (eregi(".ask.com",$agent)) {$c_brw="Robot Ask.com";}
   elseif (eregi("BecomeBot",$agent)) {$c_brw="Robot Become.com";}
   elseif (eregi("dir.com",$agent)) {$c_brw="Robot Dir.com";}
   elseif (eregi("Exabot",$agent)) {$c_brw="Robot Exalead.com";}
   elseif (eregi("www.gigablast.com",$agent)) {$c_brw="Robot Gigablast.com";}
   elseif (eregi("Girafabot",$agent)) {$c_brw="Robot Girafa.com";}
   elseif (eregi("Googlebot",$agent)) {$c_brw="Robot Google";}
   elseif (eregi("ia_archiver",$agent)) {$c_brw="Robot Alexa.com";}
   elseif (eregi("ichiro",$agent)) {$c_brw="Robot Goo.ne.jp";}
   elseif (eregi("inktomi.com",$agent)) {$c_brw="Robot Inktomi.com";}
   elseif (eregi("IRLbot",$agent)) {$c_brw="Robot IRL-crawler";}
   elseif (eregi("MJ12bot",$agent)) {$c_brw="Robot Majestic-12";}
   elseif (eregi("msnbot",$agent)) {$c_brw="Robot MSN";}
   elseif (eregi("petitsage.fr",$agent)) {$c_brw="Robot PetitSage.fr";}
   elseif (eregi("picsearch",$agent)) {$c_brw="Robot PicSearch.com";}
   elseif (eregi("search.ch",$agent)) {$c_brw="Robot Search.ch";}
   elseif (eregi("SimulationRobot",$agent)||eregi("proze",$agent)) {$c_brw="Robot Simulation Proze.net";}
   elseif (eregi("Yahoo",$agent)) {$c_brw="Robot Yahoo";}
   elseif (eregi("phpscan",$agent)) {$c_brw="Scanneur PHPScan";}
   elseif (eregi("Trend Micro",$agent)) {$c_brw="Scanneur Trend Micro";}
   elseif (eregi("Bluecoat DRTR",$agent)) {$c_brw="Scanneur Bluecoat DRTR";}
   elseif (eregi("PycURL",$agent)) {$c_brw="Scanneur PycURL";}
   elseif (eregi("Sphider2-mod-d627",$agent)) {$c_brw="Robot Sphider2-mod-d627";}
   elseif (eregi("Sphider2",$agent)) {$c_brw="Robot Sphider2";}
   elseif (eregi("Microsoft URL Control",$agent)) {$c_brw="Scanneur Microsoft URL Control";}
   elseif (eregi("libwww-perl",$agent)) {
    if (eregi("/5.7",$agent)) {$c_brw="Scanneur libwww-Perl 5.7";}
    elseif (eregi("/5.8",$agent)) {$c_brw="Scanneur libwww-Perl 5.8";}
    else {$c_brw="Scanneur libwww-Perl";}
   }
   elseif (eregi("bot",$agent)||eregi("detector",$agent)||eregi("scan",$agent)||eregi("php",$agent)) {$c_brw="Scanneur";}
   elseif (eregi("robot",$agent)||eregi("search",$agent)) {$c_brw="Robot";}
   return ($c_brw);
  }

 /**
  * Retourne le systme d'exploitation du visiteur d'aprs $_SERVER['HTTP_USER_AGENT'].
  * Exemple:
  * <code> <?php $os=$Visiteur-&gt;Client_OS($agent); ?> </code>
  * @param string $agent l'agent du visiteur
  * @return string le systme d'exploitation
 */
  public function Client_OS($agent) {
   if (($agent=="") || eregi("PycURL",$agent)) {$c_os="OS masqu";}
   elseif (eregi("W3C_",$agent)) {$c_os="W3C Validator";}
   elseif (eregi("Linux",$agent)||eregi("Lynx",$agent)) {$c_os="Linux";}
   elseif (eregi("Windows 95",$agent)||eregi("Win95",$agent)) {$c_os="Windows 95";}
   elseif (eregi("Windows 98",$agent)||eregi("Win98",$agent)) {$c_os="Windows 98";}
   elseif (eregi("Windows NT 4.0",$agent)|| (eregi("Win",$agent)&&eregi("NT4.0",$agent))) {$c_os="Windows NT 4.0";}
   elseif (eregi("Windows NT 5.0",$agent)|| (eregi("Win",$agent)&&eregi("2000",$agent))) {$c_os="Windows 2000";}
   elseif (eregi("Windows NT 5.1",$agent)||eregi("Windows XP 5.1",$agent)) {$c_os="Windows XP";}
   elseif (eregi("Windows NT 5.2",$agent)) {if (eregi("WOW64",$agent)) {$c_os="Windows 2003 64-bits";} else {$c_os="Windows 2003";}}
   elseif (eregi("Windows XP",$agent)) {$c_os="Windows XP";}
   elseif (eregi("Windows NT 6.0",$agent)) {$c_os="Windows Vista";}
   elseif (eregi("WinNT",$agent)||eregi("Windows NT",$agent)) {$c_os="Windows NT";}
   elseif (eregi("Win32",$agent)) {$c_os="Win32";}
   elseif (eregi("Macintosh",$agent)||eregi("Mac_PowerPC",$agent)) {$c_os="Mac OS PowerPC";}
   else {$c_os="OS inconnu";}
   return ($c_os);
  }

 /**
  * Retourne un tableau associatif contenant les rfrence des pages vues par un visiteur.
  * Exemple:
  * <code> <?php $parcours=$Visiteur-&gt;GetParcours($num_visiteur); ?> </code>
  * @param string $num_visiteur numro du visiteur
  * @return array les pages vues
 */
  public function GetParcours($num_visiteur){
   $tmp=array();
   $req="SELECT * FROM $this->DBVisite WHERE `nvisiteur`='$num_visiteur'";
   $res=mysql_query($req);
   while($page=mysql_fetch_assoc($res)) { /* on rcupre les page vues */
    array_push($tmp,$page);
   }
   return $tmp;
  }

 /**
  * Retourne un tableau associatif contenant les informations d'un visiteur dj enregistr.
  * Exemple:
  * <code> <?php $infos=$Visiteur-&gt;GetInfos($num_visiteur); ?> </code>
  * @param string $num_visiteur numro du visiteur
  * @return array les infos du visiteur
 */
  public function GetInfos($num_visiteur){
   $tmp=array();
   $req="SELECT * FROM $this->DBVisiteur WHERE `nvisiteur`='$num_visiteur'";
   $res=mysql_query($req);
   $tmp=mysql_fetch_assoc($res);
   return $tmp;
  }

 /**
  * Retourne True si le visiteur est MCC
  * @param string $IP adresse IP du visiteur
  * @return boolean True - False
 */
  public function Cest_MCC($IP){if ($IP=="212.147.59.129" OR $IP=="212.147.59.130") {return true;} else {return false;}}

 /**
  * Enregistrement de la visite.
  * Exemple:
  * <code> <?php $Visiteur-&gt;Store(); ?> </code>
 */
  public function Store(){
   if($this->ItsNew) {$this->New_visiteur();} else {$this->Old_visiteur();}
  }

 /**
  * Enregistre le nouveau visiteur dans la table visiteur et la page vue dans la table visite.
  * @access private
 */
  private function New_visiteur(){
   $heure=date("H:i:s");
   $req="INSERT INTO $this->DBVisiteur (`hostname`,`agent`,`navigat`,`systeme`,`date`,`referant`,`pays`,`ip`,`ville`,`latit`,`longit`) "
       ."VALUES ('$this->Hostname','$this->Agent','$this->Browser','$this->OS','$this->Today','$this->Referer','".AddSlashes($this->Pays)
       ."','$this->IP','$this->Ville','$this->Latitude','$this->Longitude')";
   $res=mysql_query($req);
   $req="SELECT `nvisiteur` FROM $this->DBVisiteur WHERE `ip`='$this->IP' AND `agent`='$this->Agent' AND `date`='$this->Today'";
   $res=mysql_query($req);
   $this->NoVisiteur=mysql_result($res,0,"nvisiteur");
   mysql_query("INSERT INTO $this->DBVisite (`nvisiteur`,`url`,`st_titre_page`,`heure`) "
              ."VALUES ('$this->NoVisiteur','$this->Request','".AddSlashes($this->TitrePage)."','$heure')");
  }

 /**
  * Enregistre la page vue dans la table visite
  * @access private
 */
  private function Old_visiteur(){
   $heure=date("H:i:s");
   $res=mysql_query("SELECT * FROM $this->DBVisite WHERE `nvisiteur`='$this->NoVisiteur' AND `heure`='$heure' AND `url`='$this->Request'");
   if ($res<>1) { //L'url n'a pas t visite  cette heure prscise par le visiteur
    $res=mysql_query("INSERT INTO $this->DBVisite (`nvisiteur`,`url`,`st_titre_page`,`heure`) "
               ."VALUES ('$this->NoVisiteur','$this->Request','".AddSlashes($this->TitrePage)."','$heure')");
   }
  }

 /**
  * Retourne le nom d'un pays en franais d'aprs le
  * code internationnal et vice-versa
  * @param string $nom CI ou nom complet
  * @return string nom complet ou CI
 */
  public function Abbr2Pays($nom){
$tbl_pays=array(
"ad"=>"Andorre","ae"=>"Emirats arabes unis","af"=>"Afghanistan","ag"=>"Antigua-et-Barbuda","ai"=>"Anguilla","al"=>"Albanie",
"am"=>"Armnie","an"=>"Antilles","ao"=>"Angola","aq"=>"Antarctique","ar"=>"Argentine","as"=>"Samoa Amricaines",
"at"=>"Autriche","au"=>"Australie","aw"=>"Aruba","az"=>"Azerbadjan","ba"=>"Bosnie-Herzgovine","bb"=>"Barbade",
"bd"=>"Bangladesh","be"=>"Belgique","bg"=>"Bulgarie","bh"=>"Bahren","bi"=>"Burundi","bj"=>"Bnin ","bm"=>"Bermudes",
"bn"=>"Brunei Darussalam","bo"=>"Bolivie","br"=>"Brsil","bs"=>"Bahamas","bt"=>"Bhoutan","bw"=>"Botswana","by"=>"Bilorussie",
"bz"=>"Belize","ca"=>"Canada","cc"=>"Iles cocos","cd"=>"Congo","cf"=>"Rpublique Centrafricaine","cg"=>"Congo","ch"=>"Suisse",
"ci"=>"Cte d'Ivoire","ck"=>"Iles Cook","cl"=>"Chili","cm"=>"Cameroun","cn"=>"Chine","co"=>"Colombie","cr"=>"Costa Rica",
"cs"=>"Tchcoslovaquie","cu"=>"Cuba","cv"=>"Cap-Vert","cx"=>"Ile Christmas","cy"=>"Chypre","cz"=>"Rpublique Tchque",
"de"=>"Allemagne","dj"=>"Djibouti","dk"=>"Danemark","dm"=>"Dominique","do"=>"Rpublique Dominicaine","dz"=>"Algrie",
"ec"=>"Equateur","ee"=>"Estonie","eg"=>"Egypte","eh"=>"Sahara occidental","er"=>"Erythre","es"=>"Espagne","et"=>"Ethiopie",
"eu"=>"Union Europenne","fi"=>"Finlande","fj"=>"Fidji","fk"=>"Iles Falklands","fm"=>"Micronsie","fo"=>"Ile Feroe",
"fr"=>"France","fx"=>"France","ga"=>"Gabon","gb"=>"Grande-Bretagne","gd"=>"Grenade","ge"=>"Gorgie","gf"=>"Guyane Franaise",
"gh"=>"Ghana","gi"=>"Gibraltar","gl"=>"Gronland","gm"=>"Gambie","gn"=>"Guine","gp"=>"Guadeloupe","gr"=>"Grce",
"gt"=>"Guatemala","gu"=>"Guam","gw"=>"Guine-Bissao","gy"=>"Guyane","hk"=>"Hong Kong","hn"=>"Honduras","hr"=>"Croatie",
"ht"=>"Hati","hu"=>"Hongrie","id"=>"Indonsie","ie"=>"Irlande","il"=>"Isral","in"=>"Inde","iq"=>"Iraq","ir"=>"Iran",
"is"=>"Islande","it"=>"Italie","jm"=>"Jamaque","jo"=>"Jordanie","jp"=>"Japon","ke"=>"Kenya","kg"=>"Kirghistan","kh"=>"Burkina Faso",
"ki"=>"Kiribati","km"=>"Rpublique comorienne","kn"=>"Saint-Christophe-et-Nivs","kp"=>"Core du Nord",
"kr"=>"Core du Sud","kw"=>"Kowet","ky"=>"Iles Camans","kz"=>"Kazakhstan","la"=>"Laos","lb"=>"Liban","lc"=>"Sainte-Lucie",
"li"=>"Liechtenstein","lk"=>"Sri Lanka","lr"=>"Libria","ls"=>"Lesotho","lt"=>"Lituanie","lu"=>"Luxembourg","lv"=>"Lettonie",
"ly"=>"Libye","ma"=>"Maroc","mc"=>"Monaco","md"=>"Moldavie","mg"=>"Madagascar","mh"=>"Marshall","mk"=>"Macdoine","mn"=>"Mongolie",
"mo"=>"Makau","mp"=>"Ile Mariana du nord","mr"=>"Mauritanie","ms"=>"Monteserrat","mu"=>"Maurice","mv"=>"Maldives","mw"=>"Malawi",
"mx"=>"Mexique West","my"=>"Malaisie","mz"=>"Mozambique","na"=>"Namibie","nc"=>"Nouvelle-Caldonie","ne"=>"Niger","nf"=>"Ile de Norfolk",
"ng"=>"Nigeria","ni"=>"Nicaragua","nl"=>"Pays-Bas","no"=>"Norvge","np"=>"Npal","nr"=>"Nauru","nu"=>"Niue","nz"=>"Nouvelle-Zlande",
"om"=>"Oman","pa"=>"Panama","pe"=>"Prou","pf"=>"Polynsie Franaise","pg"=>"Papouasie - Nouvelle Guine",
"ph"=>"Philippines","pk"=>"Pakistan","pl"=>"Pologne","pm"=>"St. Pierre and Miquelon","pn"=>"Pitcairn","pr"=>"Porto Rico","ps"=>"Palestine",
"pt"=>"Portugal","pw"=>"Palau","py"=>"Paraguay","qa"=>"Qatar","qp"=>"Guine quatoriale","re"=>"Runion",
"ro"=>"Roumanie","ru"=>"Fdration russe","rw"=>"Rwanda","sa"=>"Arabie saoudite","sb"=>"Iles Salomon","sc"=>"Seychelles",
"sd"=>"Soudan","se"=>"Sude","sg"=>"Singapour","sh"=>"Saint Hlne","si"=>"Slovnie","sk"=>"Slovaquie",
"sl"=>"Sierra Leone","sm"=>"Saint-Marin","sn"=>"Sngal","so"=>"Somalie","sr"=>"Suriname","st"=>"Sao Tom-et-Principe",
"su"=>"Union Sovitique","sv"=>"Salvador","sy"=>"Syrie","sz"=>"Swaziland","tc"=>"Turks et caicos","td"=>"Rpublique du Tchad",
"tg"=>"Togo","th"=>"Thalande","tj"=>"Tchtchnie","tk"=>"Iles Tokelau","tm"=>"Turkmnistan","tn"=>"Tunisie",
"to"=>"Tonga","tp"=>"Timor-oriental","tr"=>"Turquie","tt"=>"Trinit-et-Tobago","tv"=>"Tuvalu","tw"=>"Taiwan","tz"=>"Tanzanie",
"ua"=>"Ukraine","ug"=>"Ouganda","uk"=>"Royaume-Uni","us"=>"Etats Unis d'Amrique","uy"=>"Uruguay","uz"=>"Ousbkistan",
"va"=>"Vatican","vc"=>"Saint-Vincent-et-les Grenadines","ve"=>"Vnzuela","vg"=>"Iles vierges amricaines",
"vi"=>"Iles vierges britanniques ","vn"=>"Vit-Nam","vu"=>"Vanuatu","wf"=>"Wallis et Futuna","ws"=>"Samoa occidentales",
"ye"=>"Ymen","yt"=>"Mayotte","yu"=>"Yougoslavie","za"=>"Afrique du Sud","zm"=>"Zambie","zr"=>"Zare","zw"=>"Zimbabwe",
"xx"=>"Aucun");
   if ((strlen($nom)==2) && isset($tbl_pays[($nom)])){return $tbl_pays[($nom)];}
   else {
    $tbl_pays=array_flip($tbl_pays);
    $nom=ucwords(strtolower($nom));
    if (isset($tbl_pays[$nom])){return $tbl_pays[$nom];}
    return "";
   }
  }

    /**
     * Constructeur de la class<br />
     * Gnre les variables ou rcupre celles de la table visiteur.
     * Cration de l'objet $Visiteur:
     * <code> <?php $Visiteur=new MCCVisitors(); ?> </code>
     * @param string $DBVisiteur table des visiteurs (optionnel)
     * @param string $DBVisite table des visites (optionnel)
    */
     function __construct($DBVisiteur='stats_visiteur',$DBVisite='stats_visite') {
      $tc=microtime(true);
      $this->Today=date("Y-m-d");
      $this->IP=$_SERVER['REMOTE_ADDR'];
      $this->Port=$_SERVER['REMOTE_PORT'];
      $this->Referer=getenv('HTTP_REFERER');
      $this->Agent=@$_SERVER['HTTP_USER_AGENT'];
      $this->Request=getenv('REQUEST_URI');
      $this->TitrePage=$_SERVER['SERVER_NAME'].$this->Request;
      $this->BrowserLang=getenv('HTTP_ACCEPT_LANGUAGE');
      $tmp=explode(";",$this->BrowserLang); /* crer un tableau d'aprs BrowserLang */
      $tmp2=explode(",",$tmp[0]);
      $this->ArrayLang=$tmp2;
      if(isset($tmp[1])){$tmp2=explode(",",$tmp[1]); if(is_array($tmp2)){array_push($this->ArrayLang,$tmp2[1]);}}
      if(isset($tmp[2])){$tmp2=explode(",",$tmp[2]); if(is_array($tmp2)){array_push($this->ArrayLang,$tmp2[1]);}}
      $req="SELECT * FROM $this->DBVisiteur WHERE (`ip`='$this->IP' AND `agent`='$this->Agent' AND `date`='$this->Today')";
      $res=mysql_query($req);


      if (mysql_fetch_row($res)) { /* dj enregistr */
       $trec=microtime(true);
       $this->ItsNew=False;
       $this->NoVisiteur=mysql_result($res,0,"nvisiteur");
       $this->Hostname=mysql_result($res,0,"hostname");
       $this->OS=mysql_result($res,0,"systeme");
       $this->Browser=mysql_result($res,0,"navigat");
       $this->Pays=mysql_result($res,0,"pays");
       $this->Ville=mysql_result($res,0,"ville");
       $this->Latitude=mysql_result($res,0,"latit");
       $this->Longitude=mysql_result($res,0,"longit");
       $this->MTrecup=microtime(true)-$trec;
      }
      else { /* nouveau visiteur */
       $th=microtime(true);
       $clnt_host=gethostbyaddr($_SERVER['REMOTE_ADDR']);
       $this->Hostname=strtolower($clnt_host);
       $this->MThostname=microtime(true)-$th;

       function PointFin($mot){
        $fin=strrchr($mot,'.');
        if (strlen($fin>=4)) {$fin=PointFin($fin,'.');}
        return $fin;
       }
       function IP2region($vip) {
        $info_res=array();
        $info_req="http://api.hostip.info/get_html.php?ip=".$vip."&position=true";
        $info_res=@file($info_req);
        return($info_res);
       }
       function Host2pays($vhost) {
        $country="Inconnu";
        $ext=PointFin($vhost);
        if ($ext!=$vhost) {
         $ext=strtolower($ext);
         if (strlen($ext)>1) $ext=substr($ext,1);
         if (Ord($ext)>47 AND Ord($ext)<58) {
          $country=self::Abbr2Pays($ext);
          if ($country=="") {$country="Adresse IP";}
         }
         elseif (strlen($ext)==2 AND Ord($ext)>64 AND Ord($ext)<123) {$country=self::Abbr2Pays($ext);}
        }
        return ($country);
       }
      /* fin des fonctions */

      $ts=microtime(true);
      $this->Browser=self::Client_Browser($this->Agent);
      if(eregi("Robot",$this->Browser)) {$this->OS="Robot";}
      elseif(eregi("Scan",$this->Browser)) {$this->OS="Scanneur";}
      if ($this->OS=="") {$this->OS=self::Client_OS($this->Agent);}
      $this->MTsys=microtime(true)-$ts;

      if ($this->Cest_MCC($this->IP)) {
       $npcourt="ch";
       $this->Pays="Suisse";
       $this->Ville="Lausanne - Ouchy";
       $this->Latitude=46.5100;
       $this->Longitude=6.6210;
      }
      else {
       $tr=microtime(true);
       $clnt_region=IP2region($this->IP);
       @reset($clnt_region);
       $npays=strtolower(trim($clnt_region[0]));
       $npays=substr(strchr($npays,' '),1);
       $npcourt=substr(strrchr($npays,'('),1,2);
       $this->Pays=$this->Abbr2Pays($npcourt);
       if ($this->Pays=='Aucun') {$this->Pays=Host2pays($this->Hostname);}
       if ($this->Pays=='Aucun') {$this->Pays='IP Priv&eacute;e';}
       $this->Ville=trim($clnt_region[1]);
       $this->Ville=substr(strchr($this->Ville,' '),1);
       $this->Ville=AddCSlashes($this->Ville,"\0..\37!@\41..\57!@\173..\177");
       $this->Latitude=trim($clnt_region[2]);
       $this->Latitude=substr(strchr($this->Latitude,' '),1);
       $this->Longitude=trim($clnt_region[3]);
       $this->Longitude=substr(strchr($this->Longitude,' '),1);
       if ($npcourt=='xx' AND $this->Pays=='Inconnu') {$this->Ville='Inconnue';}
       if (strlen($this->Latitude)<2) {$this->Latitude=00.0000; $this->Longitude=000.0000;}
       if ($this->Ville=='\(Private Address\)') {$this->Ville='IP Priv&eacute;e';}
       else if ($this->Ville=='\(Unknown city\)' OR $this->Ville=='-') {$this->Ville='Inconnue';}
       else if ($this->Ville=='\(Unknown city?\)' OR $this->Ville=='-') {$this->Ville='Inconnue';}
       $this->MTregion=microtime(true)-$tr;
      }
     } /* fin nouveau visiteur */

     $this->MTconstruct=microtime(true)-$tc;
    } /* fin du constructeur */
}
?>