<?php
/**
 * Cette class gnre les rapports de statistique sur les visiteurs et  leurs parcours sur un site web
 * Les donnes sont stockes dans des tables MySQL.
 * !  Une connexion sur la Base de donnes doit tre ouverte.  !
 * @name MCCStats
 * @package MCC-WebStats
 * @version 0.47
 * @author Martin Coste
 * @link http://www.mc-concept.ch/contact.html
 * @copyright 2007 MC-Concept.ch
 */
class MCCStats {

 /**
  * Nom de la table des 'visiteurs'
  * @access public
  * @var string $DBVisiteur
  * @defvalue stats_visiteur
 */
 public $DBVisiteur='stats_visiteur';

 /**
  * Nom de la table des 'pages vues'
  * @access public
  * @var string $DBVisite
  * @defvalue stats_visite
 */
 public $DBVisite='stats_visite';


  /**
   * Convertit un tableau de valeur en tableau en %
   * @access private
   * @param array $tbl tableau des valeurs
   * @return array tableau en %
  */
  private function Arr_Nbre2p100($tbl){
   $total=0;
   foreach($tbl as $v) $total=$total+$v;
   reset($tbl);
   foreach($tbl as $k => $nbr) {$p100[$k]=number_format(($nbr/($total/100)),2);}
   return $p100;
  }


  /**
   * Retourne le numro du premier visiteur pour le jour $date
   * !  Une connexion sur la Base de donnes doit tre ouverte.  !
   * @param date $date format '2007-01-22'
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return integer numro du premier visiteur
  */
  public function Get_FirstNoVisiteur($date="",$DBVisiteur='stats_visiteur',$DBVisite='stats_visite'){
   $req=mysql_query("SELECT `nvisiteur` FROM $DBVisiteur WHERE `date`='$date' LIMIT 1;");
   $row=mysql_fetch_row($req);
   return $row[0];
  }

  /**
   * Retourne le numro du dernier visiteur pour le jour $date
   * !  Une connexion sur la Base de donnes doit tre ouverte.  !
   * @param date $date format '2007-01-22'
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return integer numro du dernier visiteur
  */
  public function Get_LastNoVisiteur($date="",$DBVisiteur='stats_visiteur',$DBVisite='stats_visite'){
   $req=mysql_query("SELECT `nvisiteur` FROM $DBVisiteur WHERE `date`='$date' ORDER BY `nvisiteur` DESC LIMIT 1;");
   $row=mysql_fetch_row($req);
   return $row[0];
  }

  /**
   * Retourne un tableau avec le nombre de visiteurs et le nombre de visites, [priode entre $du et $au]
   * !  Une connexion sur la Base de donnes doit tre ouverte.  !
   * @param date $du date de dbut '2007-01-22' (optionnel)
   * @param date $au date de fin '2007-01-28' (optionnel)
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return array tableau, array[0] -> nombres de visiteurs, array[1] -> nombres de visites
  */
  public function Get_ArrTotaux($du="",$au="",$DBVisiteur='stats_visiteur',$DBVisite='stats_visite'){
   if($du=="") $req=mysql_query("SELECT COUNT(*) FROM $DBVisiteur;");
   else $req=mysql_query("SELECT COUNT(*) FROM $DBVisiteur WHERE (`date`>='$du' AND `date`<='$au');");
   $nbre[0]=mysql_result($req,0,"COUNT(*)");

   if($du=="") $req=mysql_query("SELECT COUNT(*) FROM $DBVisite;");
   else {
    $first=self::Get_FirstNoVisiteur($du);
    $last=self::Get_LastNoVisiteur($au);
    $req=mysql_query("SELECT COUNT(*) FROM $DBVisite WHERE (`nvisiteur`>='$first' AND `nvisiteur`<='$last');");
   }
   $nbre[1]=mysql_result($req,0,"COUNT(*)");
   return($nbre);
  }

  /**
   * Retourne un tableau associatif contenant les types de Navigateur et leurs nombres, [priode entre $du et $au]
   * Exemple:
   * <code>
   * <?php
   * $tbl_browser=MCCStats::Get_ArrBrowser($du,$au);       tableau des nombres
   * $tbl_browser=MCCStats::Get_ArrBrowser($du,$au,1);     tableau en %
   * ?>
   * </code>
   * @param date $du date de dbut '2007-01-22'
   * @param date $au date de fin '2007-01-28'
   * @param boolean $pcent true retourne le tableau en % (optionnel)
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return array tableau des Navigateurs avec le nombre
  */
  public function Get_ArrBrowser($du,$au,$pcent=0,$DBVisiteur='stats_visiteur',$DBVisite='stats_visite') {
   $table=array();
   $req="SELECT `navigat`, COUNT(*) FROM $DBVisiteur
         WHERE (`date`>='$du' AND `date`<='$au' AND `systeme`<>'Robot' AND `systeme`<>'Scanneur' AND `systeme`<>'W3C Validator')
         GROUP BY `navigat` ORDER BY COUNT(*) DESC;";
   $res=mysql_query($req);
   while($tmp=mysql_fetch_assoc($res)) {$table[$tmp['navigat']]=$tmp['COUNT(*)'];}
   if($pcent) return self::Arr_Nbre2p100($table);
   else return $table;
  }

  /**
   * Retourne un tableau associatif contenant les types de Systmes d'exploitation et leurs nombres, [priode entre $du et $au]
   * Exemple: voir Get_ArrBrowser()
   * @param date $du date de dbut '2007-01-22'
   * @param date $au date de fin '2007-01-28'
   * @param boolean $pcent true retourne le tableau en % (optionnel)
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return array tableau des OS avec le nombre
  */
  public function Get_ArrOS($du,$au,$pcent=0,$DBVisiteur='stats_visiteur',$DBVisite='stats_visite') {
   $table=array();
   $req="SELECT `systeme`, COUNT(*) FROM $DBVisiteur
         WHERE (`date`>='$du' AND `date`<='$au' AND `systeme`<>'Robot' AND `systeme`<>'Scanneur' AND `systeme`<>'W3C Validator')
         GROUP BY `systeme` ORDER BY COUNT(*) DESC;";
   $res=mysql_query($req);
   while($tmp=mysql_fetch_assoc($res)) {$table[$tmp['systeme']]=$tmp['COUNT(*)'];}
   if($pcent) return self::Arr_Nbre2p100($table);
   else return $table;
  }

  /**
   * Retourne un tableau associatif contenant les types de Moteurs de Recherches et leurs nombres, [priode entre $du et $au]
   * Exemple: voir Get_ArrBrowser()
   * @param date $du date de dbut '2007-01-22'
   * @param date $au date de fin '2007-01-28'
   * @param boolean $pcent true retourne le tableau en % (optionnel)
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return array tableau des Navigateurs avec le nombre
  */
  public function Get_ArrSpider($du,$au,$pcent=0,$DBVisiteur='stats_visiteur',$DBVisite='stats_visite') {
   $table=array();
   $req="SELECT `navigat`, COUNT(*) FROM $DBVisiteur
         WHERE (`date`>='$du' AND `date`<='$au' AND `systeme`='Robot' AND `systeme`<>'Scanneur' AND `systeme`<>'W3C Validator')
         GROUP BY `navigat` ORDER BY COUNT(*) DESC;";
   $res=mysql_query($req);
   while($tmp=mysql_fetch_assoc($res)) {$table[$tmp['navigat']]=$tmp['COUNT(*)'];}
   if($pcent) return self::Arr_Nbre2p100($table);
   else return $table;
  }

  /**
   * Retourne un tableau associatif contenant les Pays et leurs nombres, [priode entre $du et $au]
   * Exemple: voir Get_ArrBrowser()
   * @param date $du date de dbut '2007-01-22'
   * @param date $au date de fin '2007-01-28'
   * @param boolean $pcent true retourne le tableau en % (optionnel)
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return array tableau des Navigateurs avec le nombre
  */
  public function Get_ArrCountry($du,$au,$pcent=0,$DBVisiteur='stats_visiteur',$DBVisite='stats_visite') {
   $table=array();
   $req="SELECT `pays`, COUNT(*) FROM $DBVisiteur
         WHERE (`date`>='$du' AND `date`<='$au' AND `pays`<>'' AND `systeme`<>'Robot' AND `systeme`<>'Scanneur' AND `systeme`<>'W3C Validator')
         GROUP BY `pays` ORDER BY COUNT(*) DESC;";
   $res=mysql_query($req);
   while($tmp=mysql_fetch_assoc($res)) {$table[$tmp['pays']]=$tmp['COUNT(*)'];}
   if($pcent) return self::Arr_Nbre2p100($table);
   else return $table;
  }

  /**
   * Retourne un tableau associatif contenant les <b>Pages vues</b> et leurs nombres, [priode entre $du et $au]
   * Exemple: voir Get_ArrBrowser()
   * @param date $du date de dbut '2007-01-22'
   * @param date $au date de fin '2007-01-28'
   * @param boolean $pcent true retourne le tableau en % (optionnel)
   * @param string $DBVisiteur table des visiteurs (optionnel)
   * @param string $DBVisite table des visites (optionnel)
   * @return array tableau des Navigateurs avec le nombre
  */
  public function Get_ArrPages($du="",$au="",$pcent=0,$DBVisiteur='stats_visiteur',$DBVisite='stats_visite') {
   $table=array();
   if($du=="") $req="SELECT `st_titre_page`, COUNT(*) FROM $DBVisite GROUP BY `st_titre_page` ORDER BY COUNT(*) DESC;";
   else {
    $first=self::Get_FirstNoVisiteur($du);
    $last=self::Get_LastNoVisiteur($au);
    $req="SELECT `st_titre_page`, COUNT(*) FROM $DBVisite WHERE (`nvisiteur`>='$first' AND `nvisiteur`<='$last')
          GROUP BY `st_titre_page` ORDER BY COUNT(*) DESC;";
   }
   $res=mysql_query($req);
   while($tmp=mysql_fetch_assoc($res)) {$table[$tmp['st_titre_page']]=$tmp['COUNT(*)'];}
   if($pcent) return self::Arr_Nbre2p100($table);
   else return $table;
  }

}
?>